﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ATOUCHX;

namespace atouch_p12_cz_02
{
    public partial class Form1 : Form
    {
        //Vytvoření delegáta pro komunikaci mezi vlákny
        private delegate void DelSample(int AID, object DATA);

        //Nutná definice objektů a proměnných.
        AtouchApp App = new AtouchApp();
        AtouchArch AArch = new AtouchArch();
        int Ind = 0;
        int Err;

        public Form1()
        {
            InitializeComponent();
            //Inicializace návratových událostí komunikace. Po napsání App.xxx += a dvojím 
            //stisku klávesy Tab se automaticky vytvoří obslužná těla událostí.
            AArch.Sample += new _IAtouchArchEvents_SampleEventHandler(AArch_Sample);
            AArch.Completed += new _IAtouchArchEvents_CompletedEventHandler(AArch_Completed);
        }

        void AArch_Sample(int AID, object DATA)
        {
            if (this.InvokeRequired)
            {
                //Kód je spuštěn v jiném vlákně, než které zabezpečuje vykreslování okna, proto 
                //je potřeba pomocí příkazu invoke spustit kód pro práci s oknem do vykreslovacího vlákna.
                this.Invoke(new DelSample(AArch_Sample), new Object[] { AID, DATA });
                return;
            }
            //Zde již kód běží ve vykreslovacím vlákně a je možné ovlivňovat zobrazovací prvky

            String PDtext = String.Format("{0}: ", Ind++);
            if (DATA is object[])
            {
                object[] MData = (object[])DATA;
                PDtext += String.Format("\t{0}\t\t{1}\t{2}", MData[0], MData[1], MData[2]);
            }
            PDtext += "\n";
            richTextBox1.AppendText(PDtext);
            AArch.Accept(0, true);
        }

        void AArch_Completed(int AID, int Samples)
        {
            //Tento kód je spuštěn v jiném vlákně, než které zabezpečuje vykreslování okna.
            //Nicméně zde neprovádíme žádné vykreslení a proto není potřeba spouštěť kód
            //ve vykreslovacím vlákně.

            //Konec běhu automatického archívu
            AArch.Control(0, false);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Inicializační metoda pro komunikaci přes síť DB-Net.
            Err = App.InitFromFile("hw.ini", "db.ini");
            if (Err == (Int16)AtouchX_Error_Code.arrOK)
            {
                //Inicializační metoda pro zavedení popisů archívu
                Err = AArch.InitFromFile("PD_Arch.ini");
            }
            ErrText.Text = Err.ToString();
        }

        //Ukončení komunikace se sítí DB-Net.
        private void EndProg_Click(object sender, EventArgs e)
        {
            AArch.Done();
            App.Done();
            this.Close();
        }

        //Načtení obsahu archivu z ŘS
        private void ReadArch_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            Err = AArch.Control(0, true);
            ErrText.Text = Err.ToString();
        }
    }
}
