﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ATOUCHX;

namespace atouch_p13_cz_02
{
    public partial class Form1 : Form
    {
        //Vytvoření delegátů pro komunikaci mezi vlákny
        private delegate void DelSample(int AID, object DATA);
        private delegate void DelCompleted(int AID, int Samples);

        //Nutná definice objektů a proměnných.
        AtouchApp App = new AtouchApp();
        AtouchArch AArch = new AtouchArch();
        int Ind = 0;
        int Err;
        Boolean boSample;

        public Form1()
        {
            InitializeComponent();
            //Inicializace návratových událostí komunikace. Po napsání App.xxx += a dvojím 
            //stisku klávesy Tab se automaticky vytvoří obslužná těla událostí.
            AArch.Sample += new _IAtouchArchEvents_SampleEventHandler(AArch_Sample);
            AArch.Completed += new _IAtouchArchEvents_CompletedEventHandler(AArch_Completed);
        }

        void AArch_Completed(int AID, int Samples)
        {
            if (this.InvokeRequired)
            {
                //Kód je spuštěn v jiném vlákně, než které zabezpečuje vykreslování okna, proto 
                //je potřeba pomocí příkazu invoke spustit kód pro práci s oknem do vykreslovacího vlákna.
                this.Invoke(new DelCompleted(AArch_Completed), new Object[] { AID, Samples });
                return;
            }
            //Zde již kód běží ve vykreslovacím vlákně a je možné ovlivňovat zobrazovací prvky
            //Konec čtení PD
            AArch.Control(1, false);
            if (!boSample)
                richTextBox1.AppendText("Žádný nový údaj v PD.\n");
        }

        void AArch_Sample(int AID, object DATA)
        {
            if (this.InvokeRequired)
            {
                //Kód je spuštěn v jiném vlákně, než které zabezpečuje vykreslování okna, proto 
                //je potřeba pomocí příkazu invoke spustit kód pro práci s oknem do vykreslovacího vlákna.
                this.Invoke(new DelSample(AArch_Sample), new Object[] { AID, DATA });
                return;
            }
            //Zde již kód běží ve vykreslovacím vlákně a je možné ovlivňovat zobrazovací prvky
            String PDtext = String.Format("{0}: ", Ind++);
            if (DATA is object[])
            {
                object[] MData = (object[])DATA;
                PDtext += String.Format("{0}\t{1}", MData[0], MData[9]);
            }
            PDtext += "\n";
            AArch.Accept(1, true);
            richTextBox1.AppendText(PDtext);
            boSample = true;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Inicializační metody pro komunikaci přes síť DB-Net.
            Err = App.InitFromFile("hw.ini", "db.ini");
            if (Err == (Int16)AtouchX_Error_Code.arrOK)
            {
                Err = AArch.InitFromFile("PD_Arch.ini");
            }
            ErrText.Text = Err.ToString();
        }

        //Ukončení komunikace se sítí DB-Net.
        private void EndProg_Click(object sender, EventArgs e)
        {
            AArch.Done();
            App.Done();
            this.Close();
        }

        //Načteni PD z ŘS.
        private void ReadPD_Click(object sender, EventArgs e)
        {
            boSample = false;
            Err = AArch.Control(1, true);
            ErrText.Text = Err.ToString();
        }
    }
}