﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ATOUCHX;

namespace atouch_p14_cz_02
{
    public partial class Form1 : Form
    {
        //Vytvoření delegáta pro komunikaci mezi vlákny
        private delegate void DelEndGetData(int WID, int Result, int Param, object DATA);

        //Nutná deficine objektů a proměnných.
        AtouchApp App = new AtouchApp();
        int Err;
        Object Data = new Object();

        public Form1()
        {
            InitializeComponent();
            //Inicializace návratových událostí komunikace. Po napsání App.xxx += a dvojím 
            //stisku klávesy Tab se automaticky vytvoří obslužná těla událostí.
            App.EndNetGetData += new _IAtouchAppEvents_EndNetGetDataEventHandler(App_EndNetGetData);
        }

        void App_EndNetGetData(int WID, int Result, int Param, object DATA)
        {
            if (this.InvokeRequired)
            {
                //Kód je spuštěn v jiném vlákně, než které zabezpečuje vykreslování okna, proto 
                //je potřeba pomocí příkazu invoke spustit kód pro práci s oknem do vykreslovacího vlákna.
                this.Invoke(new DelEndGetData(App_EndNetGetData), new Object[] { WID, Result, Param, DATA });
                return;
            }
            //Zde již kód běží ve vykreslovacím vlákně a je možné ovlivňovat zobrazovací prvky
            if ((Result & (Int16)AtouchX_Communication_State.atfOk) != 0)
            {   //Komunikace skončila OK.
                switch (Param)
                {
                    case 1:
                        CS1Text.Text = DATA.ToString();
                        break;
                    case 2:
                        CS1TextSec.Text = DATA.ToString();
                        break;
                    case 3:
                        CS2Text.Text = DATA.ToString();
                        break;
                    case 4:
                        CS2TextSec.Text = DATA.ToString();
                        break;
                }
            }
            else
            {   //Komunikace skončila chybou.
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Inicializační metoda pro komunikaci přes síť DB-Net.
            Err = App.InitFromFile("hw.ini", "db.ini");
            App.VariantOnly = false;
            ErrText.Text = Err.ToString();
        }

        //Ukončení komunikace se sítí DB-Net.
        private void EndProg_Click(object sender, EventArgs e)
        {
            App.Done();
            this.Close();
        }

        //Načítání proměnných z ŘS: posílá se WID a identifikační parametr.
        private void ReadCS1_Click(object sender, EventArgs e)
        {
            Err = App.NetGetData(1001000, 1);
            ErrText.Text = Err.ToString();
            if (Err == (Int16)AtouchX_Error_Code.arrOK)
            {
                Err = App.NetGetData(1001011, 2);
                ErrText.Text = Err.ToString();
            }
        }

        private void ReadCS2_Click(object sender, EventArgs e)
        {
            Err = App.NetGetData(2001000, 3);
            ErrText.Text = Err.ToString();
            if (Err == (Int16)AtouchX_Error_Code.arrOK)
            {
                Err = App.NetGetData(2001011, 4);
                ErrText.Text = Err.ToString();
            }
        }
    }
}
