﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ATOUCHX;

namespace atouch_p15_cz_02
{
    public partial class Form1 : Form
    {
        //Vytvoření delegáta pro komunikaci mezi vlákny
        private delegate void DelAlarm(int WID, int Param, object DATA);

        //Nutná definice objektů a proměnných.
        AtouchApp App = new AtouchApp();
        int Err;

        public Form1()
        {
            //Inicializace návratových událostí komunikace. Po napsání App.xxx += a dvojím 
            //stisku klávesy Tab se automaticky vytvoří obslužná těla událostí.
            App.DbAlarm += new _IAtouchAppEvents_DbAlarmEventHandler(App_DbAlarm);
            InitializeComponent();
        }

        void App_DbAlarm(int WID, int Param, object DATA)
        {
            if (this.InvokeRequired)
            {
                //Kód je spuštěn v jiném vlákně, než které zabezpečuje vykreslování okna, proto 
                //je potřeba pomocí příkazu invoke spustit kód pro práci s oknem do vykreslovacího vlákna.
                this.Invoke(new DelAlarm(App_DbAlarm), new Object[] { WID, Param, DATA });
                return;
            }
            //Zde již kód běží ve vykreslovacím vlákně a je možné ovlivňovat zobrazovací prvky
            In2Text.Text = DATA.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Inicializační metoda pro komunikaci přes síť DB-Net.
            Err = App.InitFromFile("hw.ini", "db.ini");
            App.VariantOnly = false;
            ErrText.Text = Err.ToString();
            //Zapnutí alarmu pro lokální proměnnou v PC s WIDem 31000
            Err = App.DbSetAlarm(31000, 1);
            ErrText.Text = Err.ToString();
        }

        //Ukončení komunikace se sítí DB-Net.
        private void EndProg_Click(object sender, EventArgs e)
        {
            App.Done();
            this.Close();
        }

        //Periodické vypisování lokální PC proměnné
        private void timer1_Tick(object sender, EventArgs e)
        {
            //ŘS posílá proměnnou typu Int, pro C# je to typ Int16
            Object Data = Convert.ToInt16(0);
            Err = App.LocalGetData(31000, ref Data);
            ErrText.Text = Err.ToString();
            InText.Text = Data.ToString();
        }
    }
}
